// Jeffrey Knockel <jeff250 at unm dot edu> 10/4/09
#include <sys/regdef.h>
#include <sys/syscall.h>

// unsigned long long int catalan( unsigned int n );
    .globl  catalan
    .ent    catalan
catalan:
    addiu   sp, sp, -24
    sw      ra, 20(sp)
    sw      a0, 24(sp)

    li      t0, 1
    bgt     a0, t0, $catalan_skip
    li      v1, 1       // = 1
    li      v0, 0
    b       $catalan_end

$catalan_skip:
    addiu   a0, a0, -1
    .option pic0        // call catalan(n-1)
    jal     catalan     //
    .option pic2        //
    lw      a0, 24(sp)

    sll     t1, a0, 1   // = 2(2*n-1)
    addiu   t1, t1, -1  //
    sll     t1, t1, 1   //

    move    t3, v1      // * catalan(n-1)
    move    t2, v0      // 64-bit multiply...
    multu   t1, t3
    mflo    v1
    mfhi    v0
    multu   t2, t1
    mflo    t0
    addu    v0, v0, t0

    addiu   a0, a0, 1   // / (n + 1)
    move    t0, zero
    li      t1, 64
    li      t3, 0x7fffffff

$catalan_div_loop:      // 64-bit divide...
    sll     t0, t0, 1   // assume that divisor (and thus remainder) are 32-bit
    sltu    t2, t3, v0  // this will save us a few instructions
    addu    t0, t0, t2
    sll     v0, v0, 1
    sltu    t2, t3, v1
    addu    v0, v0, t2
    sll     v1, v1, 1

    bltu    t0, a0, $catalan_div_continue
    subu    t0, t0, a0
    addiu   v1, v1, 1
    sltiu   t2, v1, 1
    addu    v0, v0, t2
    
$catalan_div_continue:
    addiu   t1, t1, -1
    bgtz    t1, $catalan_div_loop

$catalan_end:
    lw      ra, 20(sp)
    addiu   sp, sp, 24
    jr      ra

    .end    catalan
